GDAL-RASTER-PROXIMITY(1)

NAME
gdal-raster-proximity - Produces a raster proximity map

Added in version 3.12.

SYNOPSIS

    Usage: gdal raster proximity [OPTIONS] <INPUT> <OUTPUT>
    Produces a raster proximity map.
    Positional arguments:
      -i, --input <INPUT>                                      Input raster datasets [required]
      -o, --output <OUTPUT>                                    Output raster dataset [required]
    Common Options:
      -h, --help                                               Display help message and exit
      --json-usage                                             Display usage as JSON document and exit
      --config <KEY>=<VALUE>                                   Configuration option [may be repeated]
      -q, --quiet                                              Quiet mode (no progress bar)
    Options:
      -f, --of, --format, --output-format <OUTPUT-FORMAT>      Output format ("GDALG" allowed)
      --co, --creation-option <KEY>=<VALUE>                    Creation option [may be repeated]
      --overwrite                                              Whether overwriting existing output is allowed
                                                               Mutually exclusive with --append
      --append                                                 Append as a subdataset to existing output
                                                               Mutually exclusive with --overwrite
      --ot, --datatype, --output-data-type <OUTPUT-DATA-TYPE>  Output data type. OUTPUT-DATA-TYPE=Byte|Int8|UInt16|Int16|UInt32|Int32|UInt64|Int64|CInt16|CInt32|Float16|Float32|Float64|CFloat32|CFloat64|Byte|UInt16|Int16|UInt32|Int32|Float32|Float64 (default: Float32)
      -b, --band <BAND>                                        Input band (1-based index)
      --target-values <TARGET-VALUES>                          Target pixel values [may be repeated]
      --distance-units <DISTANCE-UNITS>                        Distance units. DISTANCE-UNITS=pixel|geo (default: pixel)
      --max-distance <MAX-DISTANCE>                            Maximum distance. The nodata value will be used for pixels beyond this distance (default: 0)
      --fixed-value <FIXED-VALUE>                              Fixed value for the pixels that are beyond the maximum distance (instead of the actual distance) (default: 0)
      --nodata <NODATA>                                        Specify a nodata value to use for pixels that are beyond the maximum distance
    Advanced Options:
      --if, --input-format <INPUT-FORMAT>                      Input formats [may be repeated]
      --oo, --open-option <KEY>=<VALUE>                        Open options [may be repeated]

DESCRIPTION

gdal raster proximity generates a raster proximity map indicating the Cartesian distance from the center of each pixel to the center of the nearest pixel identified as a target pixel. Target pixels are those in the source raster for which the raster pixel value is in the set of target pixel values.

This subcommand is also available as a potential step of gdal raster pipeline

  Standard options

-f, --of, --format, --output-format <OUTPUT-FORMAT>
    Which output raster format to use. Allowed values may be given by gdal --formats | grep raster | grep rw | sort

--co, --creation-option <NAME>=<VALUE>
    Many formats have one or more optional creation options that can be used to control particulars about the file created. For instance, the GeoTIFF driver supports creation options to control compression, and whether the file should be tiled.

    May be repeated.

    The creation options available vary by format driver, and some simple formats have no creation options at all. A list of options supported for a format can be listed with the --formats command line option but the documentation for the format is the definitive source of information on driver creation options. See Raster drivers format specific documentation for legal creation options for each format.

--overwrite
    Allow program to overwrite existing target file or dataset. Otherwise, by default, gdal errors out if the target file or dataset already exists.

--ot, --datatype, --output-data-type <OUTPUT-DATA-TYPE>
    Output data type among Byte, Int8, UInt16, Int16, UInt32, Int32, UInt64, Int64, CInt16, CInt32, Float32, Float64, CFloat32, CFloat64.

-b, --band <BAND>
    Input band (1-based index)

--target-values <TARGET-VALUES>
    A single value or a comma separated list of target pixel values in the source image to be considered target pixels. If not specified, all non-zero pixels will be considered target pixels.

--max-distance <MAX-DISTANCE>
    Maximum distance to search for a target pixel. The NoData value will be output if no target pixel is found within this distance. Distance is interpreted in pixels unless --distance-units geo is specified.

--distance-units <pixel|geo>
    Units for the distance. If geo is specified, the distance will be calculated in georeferenced units (meters or degrees) using the pixel size of the input raster. Otherwise, the distance is interpreted in pixels.

--fixed-value <FIXED-VALUE>
    Define a fixed value to be written to output pixels that are within --max-distance from the target pixels, instead of the actual distance.

--nodata <NODATA>
    Nodata value for the output raster. If not specified, the NoData value of the input band will be used. If the output band does not have a NoData value, then the value 65535 will be used for floating point output types and the maximum value that can be stored will be used for the integer output types.

  Advanced options

--oo, --open-option <NAME>=<VALUE>
    Dataset open option (format specific).

    May be repeated.

--if, --input-format <format>
    Format/driver name to be attempted to open the input file(s). It is generally not necessary to specify it, but it can be used to skip automatic driver detection, when it fails to select the appropriate driver. This option can be repeated several times to specify several candidate drivers. Note that it does not force those drivers to open the dataset. In particular, some drivers have requirements on file extensions.

    May be repeated.

    Added in version 3.12.

GDALG OUTPUT (ON-THE-FLY / STREAMED DATASET)

This program supports serializing the command line as a JSON file using the GDALG output format. The resulting file can then be opened as a raster dataset using the GDALG: GDAL Streamed Algorithm driver, and apply the specified pipeline in a on-the-fly / streamed way.

NOTE: However this algorithm is not natively streaming compatible. Consequently a temporary dataset will be generated, which may cause significant processing time at opening.

EXAMPLES

  Example 1

title
    Proximity map of a raster with max distance of 3 pixels

        $ gdal raster proximity --max-distance 3  input.tif output.tif

AUTHOR
Alessandro Pasotti <elpaso@itopen.it>

COPYRIGHT
1998-2025